<template>
  <div class='container'>
    <div style='margin-left: 30%; margin-top: 20px;'>
      <button class='btn btn-outline-info' v-bind:class='{active: !showArchived}' @click='changeScope("active")'>Active</button>
      <button class='btn btn-outline-info' v-bind:class='{active: showArchived}' @click='changeScope("archived")'>Archived</button>
    </div>
    <h2>Orders:</h2>
    <span><add-order-button></add-order-button></span>
    <button class='btn btn-outline-info'  :disabled="currentPage <= 1" @click='changePage(-1)'>Prev page</button>
    <button class='btn btn-outline-info'  @click='changePage(1)'>Next page</button>
    <ul class='list-group'>
      <li v-for="order in $store.state.orders" style='padding: 50px;' class='list-group-item clearfix'>
        <order :order='order'></order>
        <br/>
        <router-link class="btn btn-outline-info app_button" :to="{path: `/orders/${order.id}` }">Go to order</router-link>
      </li>
    </ul>
  </div>
</template>

<script>
export default {
    data () {
      return {
        showArchived: false,
        currentPage: 1
      }
    },
    mounted() { 
      if(this.$store.state.logged) { 
        this.loadOrders() 
      }
    },
    methods: {
      changeScope(newScope) {
        this.$router.push({ query: { scope: newScope }})
        this.showArchived = newScope == 'archived'
        this.loadOrders() 
      },
      changePage(valueToChange) {
        let currentPage = this.$route.query.page ? parseInt(this.$route.query.page) : 1
        let newPage = currentPage + valueToChange
        if(this.$route.query.scope == 'archived') {
          this.$router.push({ query: { scope: 'archived', page: newPage}})
        } else {
          this.$router.push({ query: { page: newPage}})
        }
        this.currentPage = newPage
        this.loadOrders()
      },
      loadOrders() {
        const url = this.$route.query.scope == 'archived' ? `api/v1/orders_archived?page=${this.currentPage}` : `api/v1/orders?page=${this.currentPage}`
        this.$http.get(url).then((response) => {
          this.$store.dispatch('loadOrders', response.data.orders)
        }).catch((error) => {
          this.$root.$emit(`displayError`, (error.response.data.message)) 
        })
      }
    }
  }
</script>
